[a, fs] = wavread('test.wav');
%analog dazu: wavwrite(a, fs, 'bla.wav');
soundsc(a, fs); % Ausgabe normalisiert

a1 = a(1:5*fs, 1); % abschneiden
soundsc(a1, fs);
a2 = a(end:-2:end-5*fs, 1); % rckwrts und doppelt so schnell
soundsc(a2, fs);

plr = audioplayer(a, fs);
play(plr);
total = get(plr, 'TotalSamples');
while strcmp(get(plr, 'Running'), 'on')
   display(100.0*get(plr,'CurrentSample')/total);     
   pause(0.2);
end
stop(plr);

% analog dazu: rcdr = audiorecorder(fs, 16, 1);

% zufllige Ausschnitte zufllig zusammenkopieren
totalDuration = 10*fs;
duration = 0.5*fs;
b = zeros(totalDuration,1);
for i = 1:100
    x = randi(length(a)-duration);
    y = randi(totalDuration-duration);
    b(y:y+duration) = b(y:y+duration) + hamming(duration+1).*a(x:x+duration);
end
soundsc(b, fs);

% Pausen hart rausschneiden
env = zeros(length(a),1);
for i = 2:length(a)
   glr = abs(a(i)); 
   env(i) = env(i-1)*0.999+glr*0.001;
end
res = zeros(length(a),1);
j = 0;
for i = 1:length(a)
    if env(i) > 0.05
        j = j+1;
        res(j) = a(i);
    end
end
res = res(1:j);
soundsc(res, fs);

% Frequenzverschiebung um 10 Hz (linear, _kein_ Pitch-Shift!)
% wird nur in falschen Bssen hrbar
w = exp(2i*pi*10*(1:length(a))'/fs);
z = real(hilbert(a).*w);
soundsc(z, fs);

% Faltungshall; Impulsantwort = Early Reflections + abklingendes weies Rauschen
% FFT fr beschleunigte Faltung
n = 2^18; % FFT liebt Zweierpotenzen an Samples
z = zeros(1, n);
ac = [a(1:n)', z]; % Nullen hinten, damit vorne keine Strungen durch Periodizitt
ir = [10.^(-9.0*(1:n)/n).*randn(1,n), z]; % ber n Samples 180 dB abfallen
ir(1:0.1*fs) = 0; % die ersten 100 ms nichts
ir(1) = 100.0; % Originalsignal
ir(100) = -30.0; % Early Reflection
ir(146) = 10.0; % Early Reflection
res = real(ifft(fft(ac).*fft(ir)));
soundsc(res, fs);